%global build_plf 0
%ifarch x86_64
%if "%distro_section" == "nonfree"
%global build_plf 1
%endif
%endif
%define build_arm 0

%global GITDATE   20160415
%global GITREV    g619e6cf
%global openssl_version 1.0.2g

Name:           edk2
Version:        %{GITDATE}git%{GITREV}
Release:        %mkrel 1
Summary:        EFI Development Kit II

# There are no formal releases from upstream.
# Tarballs are created with:
# NOW: git clone https://github.com/tianocore/edk2
# From https://www.kraxel.org/repos/jenkins/edk2/
Source0:        edk2.git-%{GITREV}.tar.xz
Source1:	openssl-%{openssl_version}.tar.gz
Patch0:         basetools-arm.patch
Patch1:         0001-OvmfPkg-Don-t-build-in-QemuVideoDxe-when-we-have-CSM.patch
Patch2:         0001-pick-up-any-display-device-not-only-vga.patch
Patch3:         0001-OvmfPkg-don-t-lock-lock-umb-when-running-csm.patch
Patch4:		0001-MdeModulePkg-TerminalDxe-add-other-text-resolutions.patch
Patch5:		0001-EXCLUDE_SHELL_FROM_FD.patch

Patch10:	0001-OvmfPkg-SmbiosPlatformDxe-install-legacy-QEMU-tables.patch
Patch11:	0002-OvmfPkg-SmbiosPlatformDxe-install-patch-default-lega.patch
Patch12:	0003-OvmfPkg-SmbiosPlatformDxe-install-patch-default-lega.patch

Patch20:	0001-OvmfPkg-EnrollDefaultKeys-application-for-enrolling-.patch

Patch30:	0001-tools_def.template-take-GCC4-_-IA32-X64-prefixes-fro.patch
Patch31:	0001-OvmfPkg-disable-multi-processor-support-for-boot-tim.patch

License:        BSD
Group:          Emulators
URL:            http://sourceforge.net/apps/mediawiki/tianocore/index.php?title=EDK2

# We need to build tools everywhere, but how is still an open question
# https://bugzilla.redhat.com/show_bug.cgi?id=992180
%if %{build_plf}
ExclusiveArch:  x86_64
%else
ExclusiveArch:  %{ix86} x86_64 %{arm}
%endif

BuildRequires:  python2-devel
BuildRequires:  libuuid-devel
%if %{build_plf}
BuildRequires:	iasl
BuildRequires:	nasm
BuildRequires:	seabios
BuildRequires:	gcc-arm-linux-gnu binutils-arm-linux-gnu
BuildRequires:	gcc-aarch64-linux-gnu binutils-aarch64-linux-gnu
BuildRequires:	dosfstools
BuildRequires:	mtools
BuildRequires:	cdrkit-genisoimage
%endif

Requires:       edk2-tools%{?_isa} = %{version}-%{release}
Requires:       edk2-tools-doc%{?_isa} = %{version}-%{release}

%description
EDK II is a development code base for creating UEFI drivers, applications
and firmware images.

%package tools
Summary:        EFI Development Kit II Tools
Group:          Development/Tools
Requires:       edk2-tools-python = %{version}-%{release}

%description tools
This package provides tools that are needed to
build EFI executables and ROMs using the GNU tools.

%package tools-python
Summary:        EFI Development Kit II Tools
Group:          Development/Tools
Requires:       python
BuildArch:      noarch

%description tools-python
This package provides tools that are needed to build EFI executables
and ROMs using the GNU tools.  You do not need to install this package;
you probably want to install edk2-tools only.

%package tools-doc
Summary:        Documentation for EFI Development Kit II Tools
Group:          Development/Tools

%description tools-doc
This package documents the tools that are needed to
build EFI executables and ROMs using the GNU tools.

%if %{build_plf}
%package ovmf-ia32
Summary:	Open Virtual Machine Firmware
License:	BSD License (no advertising) with restrictions on use and redistribution
BuildArch:      noarch
%description ovmf-ia32
EFI Development Kit II
Open Virtual Machine Firmware
32bit version

%package ovmf-x64
Summary:	Open Virtual Machine Firmware
License:	BSD License (no advertising) with restrictions on use and redistribution
BuildArch:      noarch
%description ovmf-x64
EFI Development Kit II
Open Virtual Machine Firmware
64bit version

%if %{?build_arm:0}
%package arm
Summary:	Open Virtual Machine Firmware
License:	BSD License (no advertising) with restrictions on use and redistribution
BuildArch:      noarch
%description arm
EFI Development Kit II
ARM UEFI Firmware

%package aarch64
Summary:	Open Virtual Machine Firmware
License:	BSD License (no advertising) with restrictions on use and redistribution
BuildArch:      noarch
%description aarch64
EFI Development Kit II
AARCH64 UEFI Firmware
%endif

%package coreboot-ia32
Summary:	Open Virtual Machine Firmware
License:	BSD License (no advertising) with restrictions on use and redistribution
BuildArch:      noarch
%description coreboot-ia32
EFI Development Kit II
coreboot payload
32bit version

%package coreboot-x64
Summary:	Open Virtual Machine Firmware
License:	BSD License (no advertising) with restrictions on use and redistribution
BuildArch:      noarch
%description coreboot-x64
EFI Development Kit II
coreboot payload
64bit version

%endif

%prep
%setup -q -n %{name}.git
cd BaseTools 
%patch0 -p1
cd -
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch20 -p1
%patch30 -p1
%patch31 -p1
 

%if %{build_plf}
# add openssl
tar -C CryptoPkg/Library/OpensslLib -xf %{SOURCE1}
(cd CryptoPkg/Library/OpensslLib/openssl-%{openssl_version};
 patch -p1 < ../EDKII_openssl-%{openssl_version}.patch)
(cd CryptoPkg/Library/OpensslLib; ./Install.sh)
%endif
 

%build
%if %{build_plf}
source ./edksetup.sh

CC_FLAGS="-t GCC49"

CROSS_CC_FLAGS="-t GCC49"
export GCC49_ARM_PREFIX="arm-linux-gnu-"
export GCC49_AARCH64_PREFIX="aarch64-linux-gnu-"

# prepare
cp /usr/share/seabios/bios-csm.bin OvmfPkg/Csm/Csm16/Csm16.bin
make -C BaseTools

# build key encollment boot iso
build_iso()
{
	local ARCH="$1"
	local UEFI_BINDIR=$(
		echo -n Build/Ovmf${ARCH}/DEBUG_*/
		echo $ARCH | tr '[:lower:'] '[:upper:]'
	)
	local UEFI_SHELL_BINARY=$UEFI_BINDIR/Shell.efi
	local ENROLLER_BINARY=$UEFI_BINDIR/EnrollDefaultKeys.efi
	local UEFI_SHELL_IMAGE=uefi_shell_${ARCH}.img
	local ISO_IMAGE=ovmf-$(
		echo $ARCH | tr '[:upper:]' '[:lower:']
	)/UefiShell.iso

	local UEFI_SHELL_BINARY_BNAME=$(basename -- "$UEFI_SHELL_BINARY")
	local UEFI_SHELL_SIZE=$(stat --format=%s -- "$UEFI_SHELL_BINARY")
	local ENROLLER_SIZE=$(stat --format=%s -- "$ENROLLER_BINARY")

	# add 1MB then 10% for metadata
	local UEFI_SHELL_IMAGE_KB=$((
		(UEFI_SHELL_SIZE + ENROLLER_SIZE +
		 1 * 1024 * 1024) * 11 / 10 / 1024
	))

	# create non-partitioned FAT image
	rm -f -- "$UEFI_SHELL_IMAGE"
	/usr/sbin/mkdosfs -C "$UEFI_SHELL_IMAGE" -n UEFI_SHELL -- "$UEFI_SHELL_IMAGE_KB"

	export MTOOLS_SKIP_CHECK=1
	mmd	-i "$UEFI_SHELL_IMAGE"				::efi
	mmd	-i "$UEFI_SHELL_IMAGE"				::efi/boot
	mcopy	-i "$UEFI_SHELL_IMAGE"	"$UEFI_SHELL_BINARY"	::efi/boot/bootx64.efi
	mcopy	-i "$UEFI_SHELL_IMAGE"	"$ENROLLER_BINARY"	::
	mdir	-i "$UEFI_SHELL_IMAGE"	-/			::

	# build ISO with FAT image file as El Torito EFI boot image
	genisoimage -input-charset ASCII -J -rational-rock \
		-efi-boot "$UEFI_SHELL_IMAGE" -no-emul-boot \
		-o "$ISO_IMAGE" -- "$UEFI_SHELL_IMAGE"
}

# build ovmf
for cfg in pure-efi with-csm need-smm; do
	OVMF_FLAGS="$CC_FLAGS -D HTTP_BOOT_ENABLE"

	case "$cfg" in
	with-csm)
		OVMF_FLAGS="$OVMF_FLAGS -D CSM_ENABLE"
		;;
	pure-efi)
		# nothing
		;;
	need-smm)
		OVMF_FLAGS="$OVMF_FLAGS -D SECURE_BOOT_ENABLE"
		OVMF_FLAGS="$OVMF_FLAGS -D SMM_REQUIRE"
		OVMF_FLAGS="$OVMF_FLAGS -D EXCLUDE_SHELL_FROM_FD"
		;;
	esac

	build $OVMF_FLAGS -a IA32 -p OvmfPkg/OvmfPkgIa32.dsc
	mkdir -p "ovmf-ia32"
	cp Build/OvmfIa32/DEBUG_*/FV/OVMF.fd ovmf-ia32/OVMF-${cfg}.fd
	cp Build/OvmfIa32/DEBUG_*/FV/OVMF_CODE.fd ovmf-ia32/OVMF_CODE-${cfg}.fd
	cp Build/OvmfIa32/DEBUG_*/FV/OVMF_VARS.fd ovmf-ia32/OVMF_VARS-${cfg}.fd
	if [ "$cfg" = need-smm ]; then
		build_iso Ia32
	fi
	rm -rf Build/OvmfIa32

	build $OVMF_FLAGS -a X64 -p OvmfPkg/OvmfPkgX64.dsc
	mkdir -p "ovmf-x64"
	cp Build/OvmfX64/DEBUG_*/FV/OVMF.fd ovmf-x64/OVMF-${cfg}.fd
	cp Build/OvmfX64/DEBUG_*/FV/OVMF_CODE.fd ovmf-x64/OVMF_CODE-${cfg}.fd
	cp Build/OvmfX64/DEBUG_*/FV/OVMF_VARS.fd ovmf-x64/OVMF_VARS-${cfg}.fd
	if [ "$cfg" = need-smm ]; then
		build_iso X64
	fi
	rm -rf Build/OvmfX64
done

%if %{?build_arm:0}
# build arm/aarch64 firmware
ARM_FLAGS="$CROSS_CC_FLAGS"
build $ARM_FLAGS -a ARM \
    -D DEBUG_PRINT_ERROR_LEVEL=0x8040004F \
    -D HTTP_BOOT_ENABLE \
    -p ArmVirtPkg/ArmVirtQemu.dsc
build $ARM_FLAGS -a AARCH64 \
    -D DEBUG_PRINT_ERROR_LEVEL=0x8040004F \
    -D HTTP_BOOT_ENABLE \
    -p ArmVirtPkg/ArmVirtQemu.dsc
mkdir -p "arm" "aarch64"
cp Build/ArmVirtQemu-ARM/DEBUG_*/FV/*.fd arm
cp Build/ArmVirtQemu-AARCH64/DEBUG_*/FV/*.fd aarch64
for fd in {arm,aarch64}/*.fd; do
	code="${fd%.fd}-pflash.raw"
	vars="${fd%%/*}/vars-template-pflash.raw"
	dd of="$code" if="/dev/zero" bs=1M count=64
	dd of="$code" if="$fd" conv=notrunc
	dd of="$vars" if="/dev/zero" bs=1M count=64
done
%endif

# build coreboot payload
build $CC_FLAGS -a IA32 \
    -D HTTP_BOOT_ENABLE \
    -p CorebootPayloadPkg/CorebootPayloadPkgIa32.dsc
mkdir -p "coreboot-ia32"
cp Build/CorebootPayloadPkgIA32/DEBUG_*/FV/*.fd "coreboot-ia32"
build $CC_FLAGS -a IA32 -a X64 \
    -D HTTP_BOOT_ENABLE \
    -p CorebootPayloadPkg/CorebootPayloadPkgIa32X64.dsc
mkdir -p "coreboot-x64"
cp Build/CorebootPayloadPkgX64/DEBUG_*/FV/*.fd "coreboot-x64"

%else
cd BaseTools
export WORKSPACE=`pwd`

# Build is broken if MAKEFLAGS contains -j option.
unset MAKEFLAGS
make
%endif

%install
cd BaseTools
mkdir -p %{buildroot}%{_bindir}
install \
        Source/C/bin/BootSectImage \
        Source/C/bin/EfiLdrImage \
        Source/C/bin/EfiRom \
        Source/C/bin/GenCrc32 \
        Source/C/bin/GenFfs \
        Source/C/bin/GenFv \
        Source/C/bin/GenFw \
        Source/C/bin/GenPage \
        Source/C/bin/GenSec \
        Source/C/bin/GenVtf \
        Source/C/bin/GnuGenBootSector \
        Source/C/bin/LzmaCompress \
        BinWrappers/PosixLike/LzmaF86Compress \
        Source/C/bin/Split \
        Source/C/bin/TianoCompress \
        Source/C/bin/VfrCompile \
        Source/C/bin/VolInfo \
        %{buildroot}%{_bindir}

ln -f %{buildroot}%{_bindir}/GnuGenBootSector \
        %{buildroot}%{_bindir}/GenBootSector

mkdir -p %{buildroot}%{_datadir}/%{name}
install \
        BuildEnv \
        %{buildroot}%{_datadir}/%{name}

mkdir -p %{buildroot}%{_datadir}/%{name}/Conf
install \
        Conf/build_rule.template \
        Conf/tools_def.template \
        Conf/target.template \
        %{buildroot}%{_datadir}/%{name}/Conf

mkdir -p %{buildroot}%{_datadir}/%{name}/Scripts
install \
        Scripts/GccBase.lds \
        %{buildroot}%{_datadir}/%{name}/Scripts

cp -R Source/Python %{buildroot}%{_datadir}/%{name}/Python

find %{buildroot}%{_datadir}/%{name}/Python -name "*.pyd" | xargs rm

for i in build BPDG Ecc GenDepex GenFds GenPatchPcdTable PatchPcdValue TargetTool Trim UPT; do
  echo '#!/bin/sh
PYTHONPATH=%{_datadir}/%{name}/Python
export PYTHONPATH
exec python '%{_datadir}/%{name}/Python/$i/$i.py' "$@"' > %{buildroot}%{_bindir}/$i
  chmod +x %{buildroot}%{_bindir}/$i
done

%if %{build_plf}
cd -
pwd
mkdir -p %{buildroot}/usr/share/%{name}
%if %{?build_arm:0}
cp -a ovmf-* arm aarch64 coreboot-* %{buildroot}/usr/share/%{name}
%endif
cp -a ovmf-* coreboot-* %{buildroot}/usr/share/%{name}
%endif

%files tools
%{_bindir}/BootSectImage
%{_bindir}/EfiLdrImage
%{_bindir}/EfiRom
%{_bindir}/GenBootSector
%{_bindir}/GenCrc32
%{_bindir}/GenFfs
%{_bindir}/GenFv
%{_bindir}/GenFw
%{_bindir}/GenPage
%{_bindir}/GenSec
%{_bindir}/GenVtf
%{_bindir}/GnuGenBootSector
%{_bindir}/LzmaCompress
%{_bindir}/LzmaF86Compress
%{_bindir}/Split
%{_bindir}/TianoCompress
%{_bindir}/VfrCompile
%{_bindir}/VolInfo
%{_datadir}/%{name}/BuildEnv
%{_datadir}/%{name}/Conf/
%{_datadir}/%{name}/Scripts/

%files tools-python
%{_bindir}/build
%{_bindir}/BPDG
%{_bindir}/Ecc
%{_bindir}/GenDepex
%{_bindir}/GenFds
%{_bindir}/GenPatchPcdTable
%{_bindir}/PatchPcdValue
%{_bindir}/TargetTool
%{_bindir}/Trim
%{_bindir}/UPT
%{_datadir}/%{name}/Python/

%files tools-doc
%doc BaseTools/UserManuals/BootSectImage_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/Build_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/EfiLdrImage_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/EfiRom_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/GenBootSector_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/GenCrc32_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/GenDepex_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/GenFds_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/GenFfs_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/GenFv_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/GenFw_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/GenPage_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/GenPatchPcdTable_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/GenSec_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/GenVtf_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/LzmaCompress_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/PatchPcdValue_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/SplitFile_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/TargetTool_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/TianoCompress_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/Trim_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/VfrCompiler_Utility_Man_Page.rtf
%doc BaseTools/UserManuals/VolInfo_Utility_Man_Page.rtf

%if %{build_plf}

%files ovmf-ia32
%doc OvmfPkg/README
%doc FatBinPkg/License.txt
%dir /usr/share/%{name}
/usr/share/%{name}/ovmf-ia32

%files ovmf-x64
%doc OvmfPkg/README
%doc FatBinPkg/License.txt
%dir /usr/share/%{name}
/usr/share/%{name}/ovmf-x64

%if %{?build_arm:0}
%files arm
%doc FatBinPkg/License.txt
%dir /usr/share/%{name}
/usr/share/%{name}/arm

%files aarch64
%doc FatBinPkg/License.txt
%dir /usr/share/%{name}
/usr/share/%{name}/aarch64
%endif

%files coreboot-ia32
%doc FatBinPkg/License.txt
%dir /usr/share/%{name}
/usr/share/%{name}/coreboot-ia32

%files coreboot-x64
%doc FatBinPkg/License.txt
%dir /usr/share/%{name}
/usr/share/%{name}/coreboot-x64

%endif


%changelog
* Sun Apr 17 2016 tv <tv> 20160415gitg619e6cf-1.mga6
+ Revision: 1003305
- try harder to restrict OVMF build to x86_64
- restrict OVMF build to x86_64 as 'large' model is not supported elsewhere
- build OVMF image in nonfree section
- reenable debuginfo

* Sun Apr 17 2016 tv <tv> 20160415gitg619e6cf-1.mga6
+ Revision: 1003271
- update to a newer git snapshot

* Fri Apr 01 2016 tv <tv> 20151127svn18975-1.mga6
+ Revision: 997471
- imported package edk2

